QuestieInterfaceTexts = {
    ["Settings"] = {
        ["alwaysShowObjectives"] = {
            ["enUS"] = {
                ["default"] = "true",
                ["name"] = "Always Show Quest Notes",
                ["description"] = "When this option is enabled, notes for all quests are displayed on the map regardless of the quests tracking status.\n\nWhen it is disabled, notes are only shown for quests tracked in the quest log (Shift+Click a quest in the quest log to change its tracking status).",
            },
        },
        ["arrowEnabled"] = {
            ["enUS"] = {
                ["default"] = "true",
                ["name"] = "Enable Questie Arrow",
                ["description"] = "This option toggles the Questie Arrow on and off. You can make the arrow point to the nearest quest icon by clicking on a quest in the Questie Tracker.",
            },
        },
        ["boldColors"] = {
            ["enUS"] = {
                ["default"] = "false",
                ["name"] = "Questie Tracker Colors",
                ["description"] = "This option toggles two different coloring schemes for the Questie Tracker.",
            },
        },
        ["clusterQuests"] = {
            ["enUS"] = {
                ["default"] = "true",
                ["name"] = "Cluster Worldmap Notes",
                ["description"] = "This option toggles the merging of notes on the world map that are close together. It helps with seeing quest notes that would otherwise be ontop of one another (e.g. quest start notes in densely populated quest hubs). Minimap notes are not affected by this setting.",
            },
        },
        ["corpseArrow"] = {
            ["enUS"] = {
                ["default"] = "true",
                ["name"] = "Show Corpse Arrow",
                ["description"] = "This option toggles the Questie Arrow which points to the players corpse when he is dead on and off.",
            },
        },
        ["getVersion"] = QuestieVersion,
        ["hideMinimapIcons"] = {
            ["enUS"] = {
                ["default"] = "false",
                ["name"] = "Hide Minimap Icons",
                ["description"] = "This option toggles the Questie minimap notes on and off.",
            },
        },
        ["maxLevelFilter"] = {
            ["enUS"] = {
                ["default"] = "true",
                ["name"] = "Max Level Filter",
                ["description"] = "This option toggles the Max Level Filter for quest start display on and off. When it is enabled only quests up to a certain level above the player are displayed. The level is controled by the \"Max Show Level\" option.",
            },
        },
        ["maxShowLevel"] = {
            ["enUS"] = {
                ["default"] = "7",
                ["name"] = "Max Show Level",
                ["description"] = "This option controls how much the level requirement of a quest may be above the player level for the quest start to be shown on the map.",
            },
        },
        ["minimapButton"] = {
            ["enUS"] = {
                ["default"] = "true",
                ["name"] = "Show Minimap Button",
                ["description"] = "This option toggles the Questie minimap button on and off.",
            },
        },
        ["minimapZoom"] = {
            ["enUS"] = {
                ["default"] = "false",
                ["name"] = "Hide Minimap Notes",
                ["description"] = "This option toggles the Questie minimap notes on and off.",
            },
        },
        ["minLevelFilter"] = {
            ["enUS"] = {
                ["default"] = "true",
                ["name"] = "Min Level Filter",
                ["description"] = "This option toggles the Min Level Filter for quest start display on and off. When it is enabled only quests up to a certain level below the player are displayed. The level is controled by the \"Min Show Level\" option.",
            },
        },
        ["minShowLevel"] = {
            ["enUS"] = {
                ["default"] = "4",
                ["name"] = "Min Show Level",
                ["description"] = "This option controls how much the level of a quest may be below the player level for the quest start to be shown on the map.",
            },
        },
        ["resizeWorldmap"] = {
            ["enUS"] = {
                ["default"] = "false",
                ["name"] = "Resize Worldmap",
                ["description"] = "When enabled, this option resizes the World Map window from a fullscreen display to a movable window. Note that this setting might have no effect if you use separate a map addon.",
            },
            ["requiresReload"] = true,
        },
        ["showMapNotes"] = {
            ["enUS"] = {
                ["default"] = "True",
                ["name"] = "Show Map Notes",
                ["description"] = "This option toggles Questies world map and minimap notes on and off.",
            },
        },
        ["showProfessionQuests"] = {
            ["enUS"] = {
                ["default"] = "false",
                ["name"] = "Show Profession Quests",
                ["description"] = "This option toggles the quest start display of profession quests on and off.",
            },
        },
        ["showToolTips"] = {
            ["enUS"] = {
                ["default"] = "true",
                ["name"] = "Show Tooltips",
                ["description"] = "This option toggles the display of additional quest objective information in the tooltips that appear when mousing over a creature, an object or an item.",
            },
            ["requiresReload"] = true,
        },
        ["showTrackerHeader"] = {
            ["enUS"] = {
                ["default"] = "false",
                ["name"] = "Show Tracker Header",
                ["description"] = "This option toggles the display of the number of active quests in the Questie Tracker.",
            },
            ["requiresReload"] = true,
        },
        ["trackerAlpha"] = {
            ["enUS"] = {
                ["default"] = "60%",
                ["name"] = "Tracker Transparency",
                ["description"] = "This option controls how opaque the background of the Questie Tracker is displayed (if the background is enabled.",
            },
        },
        ["trackerBackground"] = {
            ["enUS"] = {
                ["default"] = "false",
                ["name"] = "Tracker Background",
                ["description"] = "This option toggles the Questie Tracker background on and off.",
            },
            ["requiresReload"] = true,
        },
        ["trackerEnabled"] = {
            ["enUS"] = {
                ["default"] = "True",
                ["name"] = "Enable Questie Tracker",
                ["description"] = "This option toggles the Questie Tracker on and off. The Questie Tracker replaces the default quest tracker and allows you to track more quests at the same time. It also enables you to show an arrow pointing to the closest objective of a quest, by clicking on the quest in the tracker.",
            },
            ["requiresReload"] = true,
        },
        ["trackerList"] = {
            ["enUS"] = {
                ["default"] = "false",
                ["name"] = "Tracker Sorting Direction",
                ["description"] = "When this option is enabled, tracker elements are added from top to bottom, meaning the list will grow downwards.\n\nWhen this option is enabled, tracker elements are added from bottom to top, meaning the list will grow upwards.",
            },
            ["requiresReload"] = true,
        },
        ["trackerMinimize"] = {
            ["enUS"] = {
                ["default"] = "false",
                ["name"] = "Minimize Tracker",
                ["description"] = "This option toggles the display of the Questie Tracker on and off.",
            },
        },
        ["trackerScale"] = {
            ["enUS"] = {
                ["default"] = "100%",
                ["name"] = "Tracker Scale",
                ["description"] = "This option controls the size of the Questie Tracker.",
            },
            ["requiresReload"] = true,
        },
    }
}
